package jcg.zheng.demo.scheduler.spring.scheduler;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.scheduling.annotation.Async;
import org.springframework.scheduling.annotation.Scheduled;
import org.springframework.stereotype.Component;

import jcg.zheng.demo.scheduler.spring.service.BusinessTask;

@Component
public class AsyncFixedDelayScheduler {

	@Autowired
	private BusinessTask service;

	Logger logger = LoggerFactory.getLogger(AsyncFixedDelayScheduler.class);

	// trigger by delay 15 seconds after previous execution, the intial execution is
	// delayed by 30 seconds
	@Scheduled(fixedDelay = 15000, initialDelay = 30000)
	@Async
	public void scheduleFixedDelayTask() {
		logger.info(" started.");

		service.doit();

		logger.info(" completed.");
	}

}
