package jcg.zheng.demo.scheduler.spring.scheduler;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.scheduling.annotation.Async;
import org.springframework.scheduling.annotation.Scheduled;
import org.springframework.stereotype.Component;

import jcg.zheng.demo.scheduler.spring.service.BusinessTask;

@Component
public class AsyncFixedRateScheduler {

	@Autowired
	private BusinessTask service;

	Logger logger = LoggerFactory.getLogger(AsyncFixedRateScheduler.class);

	// trigger with every 15 seconds, will not wait for the previous execution
	@Scheduled(fixedRate = 15000)
	@Async
	public void scheduledTask() {
		logger.info(" started.");

		service.doit();

		logger.info(" completed.");
	}

}
