package jcg.zheng.demo.scheduler.spring.scheduler;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.scheduling.annotation.Scheduled;
import org.springframework.stereotype.Component;

import jcg.zheng.demo.scheduler.spring.service.BusinessTask;

@Component
public class FixedRateScheduler_HandleException {

	@Autowired
	private BusinessTask service;

	Logger logger = LoggerFactory.getLogger(FixedRateScheduler_HandleException.class);

	// will wait for previous execution because it's not marked as Async
	@Scheduled(fixedRateString = "${scheduler.fixedrate.ms}")
	public void scheduledTask() {
		logger.info(" started.");
		boolean isCompleted = false;
		try {
			service.doit();
			isCompleted = true;
		} catch (Exception e) {
			logger.error("Caught Exception" + e.getMessage());
		} finally {
			logger.info(" completed with status=" + isCompleted);
		}
	}

}
